=== debian/changelog ===
freecell-solver (5.0.0-2) unstable; urgency=medium

  * Fix build by adding build dependency on python3-six

 -- Gergely Risko <risko@debian.org>  Mon, 31 Dec 2018 16:34:50 +0100

freecell-solver (5.0.0-1) unstable; urgency=medium

  * Imported upstream version 5.0.0
  * Added new binaries: transpose-freecell-board and
    gen-multiple-pysol-layouts
  * Changed docs from txt to asciidoc
  * Got rid of bzip2 compression flag in debian/sources
  * Use salsa instead of alioth for git packaging

 -- Gergely Risko <risko@debian.org>  Mon, 31 Dec 2018 11:53:55 +0100
