=== debian/watch ===
version=3
http://fc-solve.shlomifish.org/downloads/fc-solve/ freecell-solver-(.+).tar.xz
